#[doc = "Register `UART_RX_STATUS` reader"]
pub struct R(crate::R<UART_RX_STATUS_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<UART_RX_STATUS_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<UART_RX_STATUS_SPEC>> for R {
    fn from(reader: crate::R<UART_RX_STATUS_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `UART_RX_STATUS` writer"]
pub struct W(crate::W<UART_RX_STATUS_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<UART_RX_STATUS_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<UART_RX_STATUS_SPEC>> for W {
    fn from(writer: crate::W<UART_RX_STATUS_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `BR_COUNTER` reader - Amount of peripheral clock periods that constitute the transmission of a 0x55 data frame (sent least signficant bit first) as determined by the receiver. BR_COUNTER / 8 is the amount of peripheral clock periods that constitute a bit period. This field has valid data when INTR_RX.BAUD_DETECT is set to '1'."]
pub struct BR_COUNTER_R(crate::FieldReader<u16, u16>);
impl BR_COUNTER_R {
    pub(crate) fn new(bits: u16) -> Self {
        BR_COUNTER_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for BR_COUNTER_R {
    type Target = crate::FieldReader<u16, u16>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl R {
    #[doc = "Bits 0:11 - Amount of peripheral clock periods that constitute the transmission of a 0x55 data frame (sent least signficant bit first) as determined by the receiver. BR_COUNTER / 8 is the amount of peripheral clock periods that constitute a bit period. This field has valid data when INTR_RX.BAUD_DETECT is set to '1'."]
    #[inline(always)]
    pub fn br_counter(&self) -> BR_COUNTER_R {
        BR_COUNTER_R::new((self.bits & 0x0fff) as u16)
    }
}
impl W {
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "UART receiver status register.\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [uart_rx_status](index.html) module"]
pub struct UART_RX_STATUS_SPEC;
impl crate::RegisterSpec for UART_RX_STATUS_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [uart_rx_status::R](R) reader structure"]
impl crate::Readable for UART_RX_STATUS_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [uart_rx_status::W](W) writer structure"]
impl crate::Writable for UART_RX_STATUS_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets UART_RX_STATUS to value 0"]
impl crate::Resettable for UART_RX_STATUS_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
